﻿@model BlogIndexViewModel
@using PagedList.Mvc;
@{
    ViewBag.Title = "وبلاگ";
}

<div class="container" id="blog">
    <div class="row mt-3">
        <div class="col-12">
            <h4 class="page-title"><span>آخرین مطالب وبلاگ</span></h4>
        </div>
        <div class="col-md-9">
            <a onclick="ChangeViewMode('grid')" class="btn btn-sm btn-secondary"><i class="fa fa-th-large"></i></a>
            <a onclick="ChangeViewMode('list')" class="btn btn-sm btn-secondary"><i class="fa fa-th-list"></i></a>
            <div class="btn-group">
                <button class="btn btn-secondary btn-sm dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" style="width:120px;">
                    جدیدترین
                </button>
                <div class="dropdown-menu">
                    <a class="dropdown-item active" href="javascript:void(0)" onclick="setSort('date_desc');">جدید ترین</a>
                    <a class="dropdown-item" href="javascript:void(0)" onclick="setSort('view_desc')">پر بازدید ترین</a>
                    <a class="dropdown-item" href="javascript:void(0)" onclick="setSort('date_desc')">قدیمی ترین</a>
                </div>
            </div>
            <div class="btn-group">
                <button class="btn btn-secondary btn-sm dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" style="width:80px;">
                    نزولی
                </button>
                <div class="dropdown-menu">
                    <a class="dropdown-item active" href="javascript:void(0)">نزولی</a>
                    <a class="dropdown-item" href="javascript:void(0)">صعودی</a>
                </div>
            </div>
            <img alt="loading" hidden id="loading" src="@Url.Content("~/Content/img/loading.gif")" />
            <div id="posts-body">
                @((string)ViewBag.ViewMode == "list" ? Html.Partial("_List", Model) : Html.Partial("_Grid", Model))
            </div>
            <div class="posts-pager">
                @{ 
                    var sortParameter = ViewBag.CurrentSort != null ? $"/sort-{ViewBag.CurrentSort}" : "";
                }
                @Html.PagedListPager(Model.Posts, page => $"{Url.Action("Index", "Blog")}/page-{page}{sortParameter}")
            </div>
        </div>
        <div class="col-md-3">
            <div id="blog-sidebar">
                @Html.Partial("_Sidebar", Model.Sidebar)
            </div>
        </div>
    </div>
</div>

@section scripts{
    @Scripts.Render("~/js/jquery-pjax")
    <script type="text/javascript">
        $(document).ready(function () {
            $(document).pjax('#blog a', '#posts-body', { timeout: 5000 });
                var parameters = "@(ViewContext.RouteData.Values["parameters"]?.ToString().ToLower())".split('/');
                for (var i=0;i<parameters.length;i++)
                {
                    var key = parameters[i].split('-')[0].toLowerCase();
                    var value = parameters[i].split('-')[1];
                    switch (key)
                    {
                        case "sort":
                            $("#sort_by").val(key);
                            $('#sort_order').val(value);
                            break;
                    }
                }
            });
            $(document).on("click", "#contentPager a", function () {
                var str = $(this).attr("href").split("?")[1];
                var pageNumber = 1;
                if (str != null) {
                    pageNumber = str.split("&")[0].split("=")[1];
                }
                pjax(pageNumber);
                return false;
            });
            $("#sort_by,#sort_order")
                .change(function () {
                    pjax();
                });
            $(document)
                .on('pjax:send',
                function () {
                    $('#loading').show();
                    $('#posts-body').hide();
                });
            $(document)
                .on('pjax:complete',
                function () {
                    $('#posts-body').show();
                    $('#loading').hide();
                });
            function pjax(pageNumber) {
                $.pjax.defaults.scrollTo = 200;
                $.pjax.defaults.timeout = 10000;
                @{
                    var path = "/Blog";
                }
                var url = "@path" + prepareURL(pageNumber);
                $.pjax({ url: url, container: '#posts-body' });
            }
            function ChangeViewMode(mode) {
                document.cookie = "BlogViewMode=" + mode;
                pjax();
            }
            function prepareURL(pageNumber) {
                var sortBy=$('#sort_by').val();
                var sortOrder = $('#sort_order').val();
                var urlArray = new Array();
                //if (!(sortBy == 'latestsort' && sortOrder == 'desc'))
                    //urlArray.push(sortBy + "-" + sortOrder);
                if (pageNumber!="1" && pageNumber!=null) {
                    urlArray.push("page-" + pageNumber);
                }
                var preparedUrl = urlArray.join("/");
                if (preparedUrl != "") {
                    return "/" + preparedUrl;
                } else {
                    return "";
                }
            }
    </script>
}